#! /usr/bin/env python

import sys, re, subprocess

gcc = "gcc"

if len (sys.argv) == 2 :
   gcc = sys.argv [1]

cmd = "echo 'int main () { }' | " + gcc + " -v -x c++ -dD -E - 2>&1"

variables = [ "__GNUC__",
              "__GNUG__",
              "__GNUC_MINOR__",
              "__GNUC_PATCHLEVEL__",
              "_GNU_SOURCE",
              "__VERSION__" ]

# print "-nostdinc"

f = subprocess.Popen (cmd, shell=True, stdout=subprocess.PIPE).stdout
incl = False

for s in f :
   s = s.strip ()
   if re.match ("End of search list.", s) :
      incl = False
   if incl and s != "" :
      # print "-isystem=" + s
      print "-I " + s
   if re.match ("#include <...> search starts here:", s) :
      incl = True

   m = re.match (r"#define (\w+) (.*)", s)
   if m :
      name = m.group (1)
      value = m.group (2)

      # value = value.replace ('"', r'\"')
      # value = value.replace ("'", r"\'")
      # value = value.replace (" ", r"\ ")
      if name == "__VERSION__" :
         value = value.replace (" ", "_")
         # value = value.replace ("(", "[")
         # value = value.replace (")", "]")

      if name in variables :
         print "-U " + name
         print "-D " + name + "=" + value

f.close ()
